import React from 'react';
import defaultOptions from '../../defaultOptions';
import { Events } from '../../enums';
import { isEmpty } from '../../Utils/CommonUtils';
import { getRowValueByColumn } from '../../Utils/RowUtils';
var CellEditorBoolean = function (_a) {
    var column = _a.column, dispatch = _a.dispatch, onValueChange = _a.onValueChange, rowData = _a.rowData, rowKeyField = _a.rowKeyField;
    var value = getRowValueByColumn(rowData, column);
    return (React.createElement("input", { autoFocus: true, className: defaultOptions.css.checkbox, type: 'checkbox', ref: function (elem) { return elem && (elem.indeterminate = isEmpty(value)); }, checked: value || false, onChange: function (event) { return onValueChange(event.currentTarget.checked); }, onBlur: function () {
            var cell = { columnKey: column.key, rowKey: rowData[rowKeyField] };
            dispatch(Events.CloseEditor, { cell: cell });
        } }));
};
export default CellEditorBoolean;