import React from 'react';
import defaultOptions from '../../defaultOptions';
import { Events } from '../../enums';
import { getRowValueByColumn } from '../../Utils/RowUtils';
var CellEditorDate = function (_a) {
    var column = _a.column, dispatch = _a.dispatch, onValueChange = _a.onValueChange, rowData = _a.rowData, rowKeyField = _a.rowKeyField;
    var fieldValue = getRowValueByColumn(rowData, column);
    var value = fieldValue && fieldValue.toISOString().split('T')[0];
    return (React.createElement("input", { autoFocus: true, className: defaultOptions.css.dateInput, type: 'date', value: value || '', onChange: function (event) {
            var targetValue = event.currentTarget.value;
            onValueChange(targetValue ? new Date(targetValue) : null);
        }, onBlur: function () {
            var cell = { columnKey: column.key, rowKey: rowData[rowKeyField] };
            dispatch(Events.CloseEditor, { cell: cell });
        } }));
};
export default CellEditorDate;