import React from 'react';
import defaultOptions from '../../defaultOptions';
import { Events } from '../../enums';
import { getRowValueByColumn } from '../../Utils/RowUtils';
var CellEditorNumber = function (_a) {
    var column = _a.column, dispatch = _a.dispatch, onValueChange = _a.onValueChange, rowData = _a.rowData, rowKeyField = _a.rowKeyField;
    var value = getRowValueByColumn(rowData, column);
    return (React.createElement("input", { autoFocus: true, className: defaultOptions.css.numberInput, type: 'number', value: value || '', onChange: function (event) {
            var newValue = event.currentTarget.value;
            onValueChange(Number(newValue) || null);
        }, onBlur: function () {
            var cell = { columnKey: column.key, rowKey: rowData[rowKeyField] };
            dispatch(Events.CloseEditor, { cell: cell });
        } }));
};
export default CellEditorNumber;