import React from 'react';
import defaultOptions from '../../defaultOptions';
import { isEditableCell } from '../../Utils/CellUtils';
import { getRowEditableCells } from '../../Utils/FilterUtils';
import CellComponent from '../CellComponent/CellComponent';
import EmptyCells from '../EmptyCells/EmptyCells';
var DataRow = function (_a) {
    var columns = _a.columns, editableCells = _a.editableCells, editingMode = _a.editingMode, groupColumnsCount = _a.groupColumnsCount, dispatch = _a.dispatch, onRowDataChanged = _a.onRowDataChanged, rowData = _a.rowData, rowKeyField = _a.rowKeyField, _b = _a.selectedRows, selectedRows = _b === void 0 ? [] : _b, height = _a.height, trRef = _a.trRef;
    var rowKeyValue = rowData[rowKeyField];
    var rowEditableCells = getRowEditableCells(rowKeyValue, editableCells);
    var isSelectedRow = selectedRows.some(function (s) { return s === rowKeyValue; });
    return (React.createElement("tr", { ref: trRef, style: { height: height }, className: defaultOptions.css.row + " " + (isSelectedRow ? defaultOptions.css.rowSelected : '') },
        React.createElement(EmptyCells, { count: groupColumnsCount }),
        columns.map(function (column) { return (React.createElement(CellComponent, { column: column, editingMode: editingMode, isEditableCell: isEditableCell(editingMode, column, rowEditableCells), isSelectedRow: isSelectedRow, key: column.key, dispatch: dispatch, onRowDataChanged: onRowDataChanged, rowData: rowData, rowKeyField: rowKeyField })); })));
};
export default DataRow;