import React from 'react';
import emptyFunc from '../../emptyFunc';
import { getField } from '../../Utils/ColumnUtils';
import { filterCellValueChangeHandler } from '../../Utils/FilterUtils';
import EmptyCells from '../EmptyCells/EmptyCells';
import FilterCell from '../FilterCell/FilterCell';
var FilterRow = function (_a) {
    var columns = _a.columns, filterRow = _a.filterRow, groupColumnsCount = _a.groupColumnsCount, onOptionChange = _a.onOptionChange;
    var rowData = filterRow.reduce(function (c, f, i, array) {
        c[f.field] = f.value;
        return c;
    }, {});
    return (React.createElement("tr", { className: 'ka-filter-row ka-tr' },
        React.createElement(EmptyCells, { count: groupColumnsCount }),
        columns.map(function (column) {
            return (React.createElement(FilterCell, { key: column.key, column: column, field: getField(column), rowKeyField: '', isSelectedRow: false, dispatch: emptyFunc, rowData: rowData, onValueChange: function (value) {
                    filterCellValueChangeHandler(value, column.key, filterRow, onOptionChange);
                } }));
        })));
};
export default FilterRow;