import * as React from 'react';
import defaultOptions from '../../defaultOptions';
import { Events, SortDirection, SortingMode } from '../../enums';
import { getColumnWithUpdatedSortDirection } from '../../Utils/HeadRowUtils';
var HeadCellContent = function (props) {
    var headCell = props.column.headCell;
    if (headCell) {
        return headCell(props);
    }
    var column = props.column, _a = props.column, title = _a.title, sortDirection = _a.sortDirection, dispatch = props.dispatch, sortingMode = props.sortingMode;
    var isSortingEnabled = sortingMode === SortingMode.Single;
    var sortClick = isSortingEnabled ? function () {
        var updatedColumn = getColumnWithUpdatedSortDirection(column);
        dispatch(Events.SortingChanged, { column: updatedColumn });
    } : undefined;
    return (React.createElement("div", { className: "ka-thead-cell-content " + (isSortingEnabled ? 'ka-pointer' : ''), onClick: sortClick },
        React.createElement("span", null, title),
        sortDirection && isSortingEnabled && (React.createElement("span", { className: sortDirection === SortDirection.Ascend
                ? defaultOptions.css.iconSortArrowUp
                : defaultOptions.css.iconSortArrowDown }))));
};
export default HeadCellContent;