var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import * as React from 'react';
import defaultOptions from '../../defaultOptions';
import { EditingMode, SortingMode } from '../../enums';
import { getOnEventHandler } from '../../Utils/EventUtils';
import { filterData, searchData } from '../../Utils/FilterUtils';
import { sortData } from '../../Utils/SortUtils';
import { convertToColumnTypes } from '../../Utils/TypeUtils';
import FilterRow from '../FilterRow/FilterRow';
import HeadRow from '../HeadRow/HeadRow';
import TableBody from '../TableBody/TableBody';
export var Table = function (props) {
    var _a = props.editableCells, editableCells = _a === void 0 ? [] : _a, _b = props.editingMode, editingMode = _b === void 0 ? EditingMode.None : _b, filterRow = props.filterRow, groups = props.groups, onOptionChange = props.onOptionChange, search = props.search, _c = props.selectedRows, selectedRows = _c === void 0 ? [] : _c, _d = props.sortingMode, sortingMode = _d === void 0 ? SortingMode.None : _d;
    var columns = props.columns, data = props.data;
    data = search ? searchData(columns, data, search) : data;
    data = convertToColumnTypes(data, columns);
    data = filterRow ? filterData(data, filterRow) : data;
    data = sortData(columns, data);
    var groupColumnsCount = 0;
    var groupedColumns = [];
    if (groups) {
        groupColumnsCount = groups.length;
        groupedColumns = columns.filter(function (c) { return groups.some(function (g) { return g.columnKey === c.key; }); });
        columns = columns.filter(function (c) { return !groups.some(function (g) { return g.columnKey === c.key; }); });
    }
    var tableOnEvent = getOnEventHandler(props);
    return (React.createElement("div", { className: 'ka' },
        React.createElement("table", { className: defaultOptions.css.table },
            React.createElement("thead", { className: defaultOptions.css.thead },
                React.createElement(HeadRow, { groupColumnsCount: groupColumnsCount, columns: columns, dispatch: tableOnEvent, sortingMode: sortingMode }),
                filterRow &&
                    (React.createElement(FilterRow, { columns: columns, filterRow: filterRow, groupColumnsCount: groupColumnsCount, onOptionChange: onOptionChange }))),
            React.createElement(TableBody, __assign({}, props, { columns: columns, data: data, editableCells: editableCells, editingMode: editingMode, groupColumnsCount: groupColumnsCount, groupedColumns: groupedColumns, dispatch: tableOnEvent, selectedRows: selectedRows })))));
};