var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import * as React from 'react';
import defaultOptions from '../../defaultOptions';
import { Events } from '../../enums';
import { getExpandedGroups, getGroupedData } from '../../Utils/GroupUtils';
import VirtualizedRows from '../VirtualizedRows/VirtualizedRows';
var TableBody = function (props) {
    var data = props.data, groupedColumns = props.groupedColumns, groups = props.groups, dispatch = props.dispatch, onOptionChange = props.onOptionChange;
    var groupsExpanded = props.groupsExpanded;
    var groupedData = groups ? getGroupedData(data, groups, groupedColumns, groupsExpanded) : data;
    if (groups && !groupsExpanded) {
        onOptionChange({ groupsExpanded: getExpandedGroups(groupedData) });
        return React.createElement(React.Fragment, null);
    }
    return (React.createElement("tbody", { className: defaultOptions.css.tbody, onScroll: function (event) {
            dispatch(Events.ScrollTable, { scrollTop: event.currentTarget.scrollTop, timeStamp: event.timeStamp });
        } },
        React.createElement(VirtualizedRows, __assign({}, props, { data: groupedData }))));
};
export default TableBody;