var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import React, { useEffect, useRef } from 'react';
import { Events } from '../../enums';
import { getGroupMark } from '../../Utils/GroupUtils';
import { getVirtualized } from '../../Utils/Virtualize';
import DataRow from '../DataRow/DataRow';
import GroupRow from '../GroupRow/GroupRow';
var VirtualizedRows = function (props) {
    var columns = props.columns, data = props.data, dispatch = props.dispatch, _a = props.groups, groups = _a === void 0 ? [] : _a, _b = props.groupsExpanded, groupsExpanded = _b === void 0 ? [] : _b, onOptionChange = props.onOptionChange, rowKeyField = props.rowKeyField, virtualScrolling = props.virtualScrolling;
    var groupMark = getGroupMark();
    var firstRowRef = useRef(null);
    useEffect(function () {
        if (firstRowRef
            && firstRowRef.current
            && (virtualScrolling
                && (!virtualScrolling.itemHeight
                    || !virtualScrolling.tbodyHeight))) {
            var itemHeight = firstRowRef.current.offsetHeight || 40;
            var tbodyHeight = (firstRowRef.current.parentElement && firstRowRef.current.parentElement.offsetHeight) || 600;
            var newVirtualScrolling = __assign({ itemHeight: itemHeight,
                tbodyHeight: tbodyHeight }, virtualScrolling);
            onOptionChange({ virtualScrolling: newVirtualScrolling });
        }
    }, [firstRowRef, onOptionChange, virtualScrolling]);
    var virtualizedData = data;
    var virtualized;
    if (virtualScrolling) {
        virtualized = getVirtualized(virtualScrolling, virtualizedData);
        virtualizedData = virtualized.virtualizedData;
    }
    var rowDataChangedEvent = dispatch && dispatch.bind(null, Events.RowDataChanged);
    var rowRefLink = firstRowRef;
    return (React.createElement(React.Fragment, null,
        virtualized && React.createElement("tr", { style: { height: virtualized.beginHeight } }),
        virtualizedData.map(function (d) {
            if (d.groupMark === groupMark) {
                return (React.createElement(GroupRow, { key: d.key, groupRowData: d, columns: columns, emptyColumnsCount: d.key.length - 1, groups: groups, groupsExpanded: groupsExpanded, onOptionChange: onOptionChange }));
            }
            else {
                var dataRow = (React.createElement(DataRow, __assign({}, props, { trRef: rowRefLink, key: d[rowKeyField], rowData: d, onRowDataChanged: rowDataChangedEvent })));
                rowRefLink = undefined;
                return dataRow;
            }
        }),
        virtualized && React.createElement("tr", { style: { height: virtualized.endHeight } })));
};
export default VirtualizedRows;