import { KeyboardEnum } from '../enums';
/*
  Used inside effects and returned as result from them,
  it adds listener to esc & enter keys on life cycle of component
*/
export var addEscEnterKeyEffect = function (escKeyHandler, enterKeyHandler) {
    var handleKeyboard = function (event) {
        if (event.keyCode === KeyboardEnum.Esc) {
            escKeyHandler();
        }
        if (event.keyCode === KeyboardEnum.Enter) {
            enterKeyHandler();
        }
    };
    return getEventListenerEffect('keyup', handleKeyboard);
};
export var getEventListenerEffect = function (eventName, handler) {
    window.addEventListener(eventName, handler);
    return function () {
        window.removeEventListener(eventName, handler);
    };
};