import { getCopyOfArrayAndDeleteItem, getCopyOfArrayAndInsertOrReplaceItem } from './ArrayUtils';
import { getField } from './ColumnUtils';
import { isEmpty } from './CommonUtils';
export var getRowEditableCells = function (rowKeyValue, editableCells) {
    return editableCells ? editableCells.filter(function (c) { return c.rowKey === rowKeyValue; }) : [];
};
export var searchData = function (columns, data, searchText) {
    return columns.reduce(function (initialData, c) {
        var filterFunction = function (item) {
            return c.search ? c.search(searchText, item, c) : initialData.indexOf(item) < 0
                && item[getField(c)].toString().toLowerCase().includes(searchText.toLowerCase());
        };
        return initialData.concat(data.filter(filterFunction));
    }, []);
};
export var filterData = function (data, filterRow) {
    return filterRow.reduce(function (initialData, f) {
        var searcFunc = typeof f.value === 'string' ? function (d) { return d[f.field].toLowerCase().includes(f.value.toLowerCase()); }
            : function (d) { return d[f.field] === f.value; };
        return initialData.filter(searcFunc);
    }, data);
};
export var filterCellValueChangeHandler = function (value, field, filterRow, optionChangeHandler) {
    var newFilterRow;
    var newFRValue = {
        field: field,
        operator: '=',
        value: value,
    };
    newFilterRow = isEmpty(value) ? getCopyOfArrayAndDeleteItem(newFRValue, 'field', filterRow)
        : getCopyOfArrayAndInsertOrReplaceItem(newFRValue, 'field', filterRow);
    optionChangeHandler({ filterRow: newFilterRow });
};