var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
import { getField } from './ColumnUtils';
var groupMark = {};
export var groupClick = function (groupsExpanded, groupRowData, onOptionChange) {
    var newGroupsExpanded = groupsExpanded.filter(function (ge) { return JSON.stringify(ge) !== JSON.stringify(groupRowData.key); });
    if (newGroupsExpanded.length === groupsExpanded.length) {
        newGroupsExpanded.push(groupRowData.key);
    }
    onOptionChange({ groupsExpanded: newGroupsExpanded });
};
export var getExpandedGroups = function (groupedData) {
    var groupsExpanded = [];
    for (var _i = 0, groupedData_1 = groupedData; _i < groupedData_1.length; _i++) {
        var value = groupedData_1[_i];
        if (value.groupMark === groupMark) {
            groupsExpanded.push(value.key);
        }
    }
    return groupsExpanded;
};
export var getGroupedData = function (data, groups, groupedColumns, groupsExpanded) {
    var columnMap = {};
    groupedColumns.forEach(function (c) { return columnMap[c.key] = getField(c); });
    var grouped = getGroupedStructure(data, groups, columnMap, 0, groupsExpanded);
    return convertToFlat(grouped);
};
export var convertToFlat = function (grouped, key) {
    if (key === void 0) { key = []; }
    var result = [];
    grouped.forEach(function (value, groupValue) {
        var groupKey = __spreadArrays(key);
        groupKey.push(groupValue);
        result.push({ groupMark: groupMark, key: groupKey, value: groupValue });
        if (Array.isArray(value)) {
            value.forEach(function (item) {
                result.push(item);
            });
        }
        else {
            result = result.concat(convertToFlat(value, groupKey));
        }
    });
    return result;
};
export var getGroupedStructure = function (data, groups, columnMap, expandedDeep, groupsExpanded) {
    if (expandedDeep === void 0) { expandedDeep = 0; }
    groups = __spreadArrays(groups);
    var group = groups.shift();
    if (group) {
        var grouped_1 = groupBy(data, function (item) { return item[columnMap[group.columnKey]]; });
        grouped_1.forEach(function (value, key) {
            var groupExpandedItems = groupsExpanded && groupsExpanded.filter(function (ge) { return ge[expandedDeep] === key; });
            var isThisGroupExpanded = !groupExpandedItems
                || groupExpandedItems.some(function (ge) { return ge.length === expandedDeep + 1; });
            if (isThisGroupExpanded) {
                var newStructure = getGroupedStructure(value, groups, columnMap, expandedDeep + 1, groupExpandedItems && groupExpandedItems.filter(function (ge) { return ge.length > expandedDeep + 1; }));
                if (newStructure) {
                    grouped_1.set(key, newStructure);
                }
            }
            else {
                grouped_1.set(key, []);
            }
        });
        return grouped_1;
    }
};
export var groupBy = function (data, keyGetter, isEmptyValue) {
    if (isEmptyValue === void 0) { isEmptyValue = false; }
    var map = new Map();
    data.forEach(function (item) {
        var key = keyGetter(item);
        if (isEmptyValue) {
            map.set(key, []);
        }
        else {
            var collection = map.get(key);
            if (!collection) {
                map.set(key, [item]);
            }
            else {
                collection.push(item);
            }
        }
    });
    return map;
};
export var getGroupMark = function () { return groupMark; };