var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
import { DataType } from '../enums';
import { getField } from './ColumnUtils';
export var convertToColumnTypes = function (data, columns) {
    var newData = data.map(function (d) {
        var nd = __assign({}, d);
        columns.forEach(function (c) {
            var field = getField(c);
            if (nd[field] != null) {
                switch (c.dataType) {
                    case DataType.String:
                        nd[field] = nd[field].toString();
                        break;
                    case DataType.Number:
                        nd[field] = Number(nd[field]);
                        break;
                    case DataType.Date:
                        nd[field] = new Date(nd[field]);
                        break;
                    case DataType.Boolean:
                        nd[field] = toBoolean(nd[field]);
                        break;
                }
            }
        });
        return nd;
    });
    return newData;
};
export var toBoolean = function (value) {
    if (typeof value === 'string') {
        switch (value.toLowerCase().trim()) {
            case 'true':
            case 'yes':
            case '1': return true;
            case 'false':
            case 'no':
            case '0':
            case null: return false;
        }
    }
    return Boolean(value);
};